;==============================================================================
; (c) Copyright Elect Software International Inc., 1992, Toronto. Anyone can
; use this code for anything as long as it is not resold as a software
; development resource, as long as the copyright notice isn't removed, as
; long as changes are clearly marked as to authorship, and as long as users
; indemnify Elect from any liability.
; Comments welcome. Henrik Bechmann, CIS:72701,3717; Tel:416-534-8176.
;==============================================================================

; ************************* NOT USED BY MENUBOX *************************

; The following are methods that popups other than MenuBox use in our 
; applications...

Proc Box.WriteTitle(Title)
   @Box_WindowRow - 2,Box_WindowCol
   Style Attribute Box_TitleColors
   ?? Format("AC,W" + StrVal(Box_WindowWidth),Title)
   Style
EndProc
Writelib    LibrarySpec    Box.WriteTitle
Release     Procs          Box.WriteTitle

Proc Box.WriteFootNote(FootNote)
   Private
      Variance
   @ Box_WindowRow + Box_WindowLength, Box_WindowCol
   Style Attribute Box_BorderColors
   ?? Fill(Box.HorizontalChar,Box_WindowWidth)
   If FootNote <> "" Then
      Variance = (Len(Footnote) + 2) - Box_WindowWidth
      If Variance > 0 Then
         FootNote = Substr(Footnote,Variance + 1,254)
      Endif
      FootNote = "[" + Footnote + "]"
      @ Box_WindowRow + Box_WindowLength, Box_WindowCol +
                      int((Box_WindowWidth - Len(FootNote))/2)
      ?? FootNote
   Endif
   Style
EndProc
Writelib    LibrarySpec    Box.WriteFootNote
Release     Procs          Box.WriteFootNote

Proc Box.WriteBlinkingFootNote(FootNote)
   Private
      Variance,
      ScreenRow,
      ScreenCol
   @ Box_WindowRow + Box_WindowLength, Box_WindowCol
   Style Attribute Box_BorderColors
   ?? Fill(Box.HorizontalChar,Box_WindowWidth)
   If FootNote <> "" Then
      Variance = (Len(Footnote) + 2) - Box_WindowWidth
      If Variance > 0 Then
         FootNote = Substr(Footnote,Variance + 1,254)
      Endif
      FootNote = "[" + Footnote + "]"
      @ Box_WindowRow + Box_WindowLength, Box_WindowCol +
                      int((Box_WindowWidth - Len(FootNote))/2)
      ScreenRow = Row()
      ScreenCol = Col()
      Style Attribute Box_BorderColors + 128 ; Blinking
      ?? FootNote
   Endif
   Style
EndProc
Writelib    LibrarySpec    Box.WriteBlinkingFootNote
Release     Procs          Box.WriteBlinkingFootNote

Proc Box.WriteString(WriteRow,WriteCol,String)
   Private
      Length,
      Variance
   If WriteRow > Box_WindowLength Then
      Return
   Endif
   Length = Len(String)
   Variance = (Length + WriteCol - 1) - Box_WindowWidth
   If Variance > 0 Then
      String = Substr(String,1,Length - Variance)
   Endif
   @ Box_WindowRow + WriteRow - 1, Box_WindowCol + WriteCol - 1
   Style Attribute Box_WindowColors
   ?? String
   Style
EndProc
Writelib    LibrarySpec    Box.WriteString
Release     Procs          Box.WriteString

Proc Box.WriteBorderColorString(WriteRow,WriteCol,String)
   @ Box_WindowRow + WriteRow - 1, Box_WindowCol + WriteCol - 1
   Style Attribute Box_BorderColors
   ?? String
   Style
EndProc
Writelib    LibrarySpec    Box.WriteBorderColorString
Release     Procs          Box.WriteBorderColorString

Proc Box.WriteHighlightString(WriteRow,WriteCol,String)
   @ Box_WindowRow + WriteRow - 1, Box_WindowCol + WriteCol - 1
   Style Attribute Box_HighlightColors
   ?? String
   Style
EndProc
Writelib    LibrarySpec    Box.WriteHighlightString
Release     Procs          Box.WriteHighlightString

Proc Box.WriteVariable(WriteRow,WriteCol,Variable)
   Private
      Length,
      Variance
   If WriteRow > Box_WindowLength Then
      Return
   Endif
   @ Box_WindowRow + WriteRow - 1, Box_WindowCol + WriteCol - 1
   Style Attribute Box_WindowColors
   ?? Variable
   Style
EndProc
Writelib    LibrarySpec    Box.WriteVariable
Release     Procs          Box.WriteVariable

Proc Box.ClearRow(WriteRow)
   If WriteRow > Box_WindowLength Then
      Return
   Endif
   @ Box_WindowRow + WriteRow - 1, Box_WindowCol
   Style Attribute Box_WindowColors
   ?? Fill(" ",Box_WindowWidth)
   Style
EndProc
Writelib    LibrarySpec    Box.ClearRow
Release     Procs          Box.ClearRow

Proc Box.HighLightArea(TopLeftRow,TopLeftCol,
                       BottomRightRow,BottomRightCol)
   PaintCanvas
      Attribute Box_HighlightColors
      Box_WindowRow + TopLeftRow - 1,
      Box_WindowCol + TopLeftCol - 1,
      Box_WindowRow + BottomRightRow - 1,
      Box_WindowCol + BottomRightCol - 1
EndProc
Writelib    LibrarySpec    Box.HighLightArea
Release     Procs          Box.HighLightArea

Proc Box.HighLightHotSpot(HighLightRow,LeftCol,RightCol,HotBoxColors)
   PaintCanvas
      Attribute HotBoxColors
      Box_WindowRow + HighLightRow - 1,
      Box_WindowCol + LeftCol - 1,
      Box_WindowRow + HighLightRow - 1,
      Box_WindowCol + RightCol - 1
EndProc
Writelib    LibrarySpec    Box.HighLightHotSpot
Release     Procs          Box.HighLightHotSpot

Proc Box.BodyColorArea(TopLeftRow,TopLeftCol,
                       BottomRightRow,BottomRightCol)
   PaintCanvas
      Attribute Box_WindowColors
      Box_WindowRow + TopLeftRow - 1,
      Box_WindowCol + TopLeftCol - 1,
      Box_WindowRow + BottomRightRow - 1,
      Box_WindowCol + BottomRightCol - 1
EndProc
Writelib    LibrarySpec    Box.BodyColorArea
Release     Procs          Box.BodyColorArea

Proc Box.MoreLeftArrow(LogicalValue)
   @Box_WindowRow - 1,Box_WindowCol - 2
   Style Attribute Box_BorderColors
   If LogicalValue Then
      ?? ""
   Else
      ?? " "
   Endif
   Style
EndProc
Writelib    LibrarySpec    Box.MoreLeftArrow
Release     Procs          Box.MoreLeftArrow

Proc Box.MoreRightArrow(LogicalValue)
   @Box_WindowRow - 1,Box_WindowCol + Box_WindowWidth + 1
   Style Attribute Box_BorderColors
   If LogicalValue Then
      ?? ""
   Else
      ?? " "
   Endif
   Style
EndProc
Writelib    LibrarySpec    Box.MoreRightArrow
Release     Procs          Box.MoreRightArrow

Proc Box.Divider(DividerRow)
   If DividerRow > Box_WindowLength Then
      Return false
   Endif
   @ Box_WindowRow + DividerRow - 1, Box_WindowCol - 1
   Style Attribute Box_BorderColors
   ?? Box.LeftCentreChar
   ?? Fill(Box.HorizontalChar,Box_WindowWidth)
   ?? Box.RightCentreChar
   Style
EndProc
Writelib    LibrarySpec    Box.Divider
Release     Procs          Box.Divider

Proc Box.SetCursorPos(WindowRow,WindowCol)
   @ Box_WindowRow + WindowRow - 1, Box_WindowCol + WindowCol - 1
EndProc
Writelib    LibrarySpec    Box.SetCursorPos
Release     Procs          Box.SetCursorPos
